;Serial port access if you want to modify I2C DA values
;11,059MHz, 19200 Baud (or change SMOD1)
#include LPx052.H

SDA      .equ  92h             ; Port 1.2
SCL      .equ  93h             ; Port 1.3

         .org 0000H

INIT     mov   P1M0,#00H       ; set ports to quasi bi-direc
         mov   P1M1,#00H
         mov   P3M0,#00H
         mov   P3M1,#00H
         clr   TR1             ; stop timer 0 / 1 
         mov   TH1,#0DCH       ; 256-6: 9600 baud
         mov   TL1,#0DCH       ; 11.059MHz for SMOD1 =0 
         anl   TMOD,#00H       ; Timer1: 8 bit auto-reload
         orl   TMOD,#20H       ; Timer0: Mode 0
         setb  TR1             ; TCON start timer 
         anl   PCON,#3FH       ; PCON: clear SM0D0 and SM0D0
         mov   SCON,#50H       ; InitRS232 8 bit UART Mode1
         setb  TI
         orl   PCON,#80H       ; SMOD=1 double Baudrate

         acall I2Init          ; init

; MAX 5382 MEUK : adr=62, SCL max 400 khz = 2,5 us
; settling time 20 us

NEXT     acall I2Start 
         mov   a,#62H          ; I2C adr      
         acall I2Out           ; return A= 0 = error        
         mov   a,R1            ; I2C data
         acall I2Out
         acall I2Stop

         mov   r2,#50          ; MAX DA settling time 
loops    djnz  R2,loops        ; R2 * 90ns * 3cyc
         dec   R1              ; next value
         sjmp  NEXT


Delay    nop                   ; I2C command delay
         nop
         nop
         nop
         nop
         nop
         ret    

I2Init   setb  SDA
         setb  SCL
         ret

I2Start  clr   SDA
         acall Delay
         clr   SCL
         ret

I2Stop   clr   SCL            ; ????
         clr   SDA
         acall Delay
         setb  SCL
         acall Delay
         setb  SDA
         ret

I2Out    mov   r3,#8          ; 8 bits
S0       jb    ACC.7,S1       ; bit 7 = 1?
         clr   SDA            ; bit = 0
         sjmp  S2             ; bit = 1
S1       setb  SDA            ; bit = 1
S2       acall Delay
         setb  SCL            ; clock
         acall Delay
         clr   SCL
         rl    a              ; next bit in A
         djnz  r3,S0          ; 8 bits 
         setb  SDA            ; SDA high Z
         acall Delay
         setb  SCL            ; clock 9
         acall Delay
         jb    SDA,Err        ; Ack?
         clr   SCL
         clr   SDA 
         acall Delay
         ret
Err      mov   A,#0           ; error: return 0 
         clr   SCL
         clr   SDA 
         acall Delay
         ret
                              ; ser com
RX       jnb   RI,RX          ; get from user
         mov   A,SBUF
         clr   RI
         ret

TX       jnb   TI,TX          ; committ value
         clr   TI
         mov   SBUF,A
         ret
        .end
